﻿using Styx;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using L = _Perdition_s_Reprieve____Arms.Core.Utilities.Log;
using U = _Perdition_s_Reprieve____Arms.Core.Unit;
#endregion

namespace _Perdition_s_Reprieve____Arms.Core
{
    class Spell
    {
        public static int lastSpellCast;
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Cooldown Detection
        public static double cooldownTimeLeft(int Spell)
        {
            try
            {
                SpellFindResults Results;
                return SpellManager.FindSpell(Spell, out Results) ? (Results.Override != null ? Results.Override.CooldownTimeLeft.TotalMilliseconds : Results.Original.CooldownTimeLeft.TotalMilliseconds) : 9999;
            }
            catch (Exception xException)
            {
                L.diagnosticsLog("Exception in cooldownTimeLeft(); ", xException);
                return 0000;
            }
        }
        public static bool onCooldown(int Spell)
        {
            try
            {
                SpellFindResults Results;
                if (SpellManager.FindSpell(Spell, out Results)) { return Results.Override != null ? Results.Override.Cooldown : Results.Original.Cooldown; }
                return false;
            }
            catch (Exception xException)
            {
                L.diagnosticsLog("Exception in cooldownTimeLeft(); ", xException);
                return false;
            }
        }
        #endregion

        #region [Method] - Spell Casting
        public static async Task<bool> Buff(int Spell, bool reqs)
        {
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(Spell), Me, false, false, false)) //Should we check for if we are moving? *Second false
                return false;
            if (!SpellManager.Cast(Spell, Me))
                return false;
            lastSpellCast = Spell;
            L.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        public static async Task<bool> Cast(int Spell, bool reqs)
        {
            if (!U.isUnitValid(currentTarget))
                return false;
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(Spell), currentTarget, false, false, false)) //Should we check for if our currentTarget is moving? *Second false
                return false;
            if (!SpellManager.Cast(Spell, currentTarget))
                return false;
            lastSpellCast = Spell;
            L.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        public static async Task<bool> GCD(int Spell, bool reqs)
        {
            if (onCooldown(Spell))
                return false;
            if (!reqs)
                return false;
            if (!SpellManager.Cast(Spell))
                return false;
            lastSpellCast = Spell;
            L.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        #endregion
    }
}
