﻿using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using HK = _Perdition_s_Reprieve____Arms.Core.Managers.Hotkeys;
using S = _Perdition_s_Reprieve____Arms.Core.Spell;
using SB = _Perdition_s_Reprieve____Arms.Core.Helpers.Spell_Book;
using T = _Perdition_s_Reprieve____Arms.Core.Managers.Talent;
using U = _Perdition_s_Reprieve____Arms.Core.Unit;
#endregion

namespace _Perdition_s_Reprieve____Arms.Rotation
{
    class Tactics
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Precombat Buffing
        //public static async Task<bool> preCombatBuffing()
        //{
        //    if (HK.manualOn || Me.Combat || !Me.IsAlive || (Me.Mounted || Me.OnTaxi))
        //        return true;
        //    //actions.precombat=flask,type=countless_armies
        //    //actions.precombat+=/food,type=nightborne_delicacy_platter
        //    //actions.precombat+=/augmentation,type=defiled
        //    //# Snapshot raid buffed stats before combat begins and pre-potting is done.
        //    //actions.precombat+=/snapshot_stats
        //    //actions.precombat+=/potion,name=deadly_grace
        //}
        #endregion

        #region [Method] - Combat Buffing
        public static async Task<bool> combatBuffing()
        {
            if (HK.manualOn || !Me.IsAlive || (!Me.GotTarget || !currentTarget.IsAlive) || (Me.Mounted || Me.OnTaxi))
                return true;
            //actions=charge

            //actions+=/auto_attack
            if (!Me.IsAutoAttacking) { Lua.DoString("StartAttack()"); return true; }
            //actions+=/potion,name=deadly_grace,if=(target.health.pct<20&buff.battle_cry.up)|target.time_to_die<=26

            //actions+=/battle_cry,if=(buff.bloodlust.up|time>=1)&!gcd.remains

            //actions+=/avatar,if=(buff.bloodlust.up|time>=1)&!gcd.remains

            //actions+=/blood_fury,if=buff.battle_cry.up|target.time_to_die<=16

            //actions+=/berserking,if=buff.battle_cry.up|target.time_to_die<=11

            //actions+=/arcane_torrent,if=buff.battle_cry_deadly_calm.down&rage.deficit>40

            //actions+=/use_item,name=gift_of_radiance

            //actions+=/hamstring,if=buff.battle_cry_deadly_calm.remains>cooldown.hamstring.remains

            //actions+=/heroic_leap,if=debuff.colossus_smash.up

            //actions+=/rend,if=remains<gcd

            //actions+=/focused_rage,if=buff.battle_cry_deadly_calm.remains>cooldown.focused_rage.remains&(buff.focused_rage.stack<3|cooldown.mortal_strike.remains)
            await S.GCD(SB.talentFocusedRage, U.battleCryDeadlyCalm && U.auraTimeLeft(Me, SB.auraBattleCry) > S.cooldownTimeLeft(SB.talentFocusedRage) && (U.focusedRage < 3 || S.onCooldown(SB.spellMortalStrike)));
            //actions+=/colossus_smash,if=debuff.colossus_smash.down
            if (await S.Cast(SB.spellColossusSmash, !U.colossusSmash)) return true;
            //actions+=/warbreaker,if=debuff.colossus_smash.down
            if (await S.Cast(SB.artifactWarbreaker, !U.colossusSmash)) return true;
            //actions+=/ravager

            //actions+=/overpower
            return await S.Cast(SB.talentOverpower, true);
        }
        #endregion

        #region [Method] - Combat Rotation

        #region [Method] - Rotation Selector
        public static async Task<bool> rotationSelector()
        {
            if (HK.manualOn || !Me.IsAlive || (!Me.GotTarget || !currentTarget.IsAlive) || (Me.Mounted || Me.OnTaxi))
                return true;
            //actions+=/run_action_list,name=cleave,if=spell_targets.whirlwind>=2&talent.sweeping_strikes.enabled
            else if (U.activeEnemies(Me.Location, 8f).Count() > 1 && T.sweepingStrikes == 1 && await Cleave()) return true;
            //actions+=/run_action_list,name=aoe,if=spell_targets.whirlwind>=2&!talent.sweeping_strikes.enabled
            else if (U.activeEnemies(Me.Location, 8f).Count() > 1 && T.sweepingStrikes == 0 && await AoE()) return true;
            //actions+=/run_action_list,name=execute,if=target.health.pct<=20
            else if (U.targetHealth < 21 && await Execute()) return true;
            //actions+=/run_action_list,name=single
            else return await singleTarget();
        }
        #endregion

        #region [Method] - Cleave
        public static async Task<bool> Cleave()
        {
            //actions.cleave=mortal_strike
            if (await S.Cast(SB.spellMortalStrike, true)) return true;
            //actions.cleave+=/execute,if=buff.stone_heart.react
            //if (await S.Cast(SB.spellExecute, U.canExecute /*&& U.stoneHeart*/)) return true; //<~ Add in Stone Heart buff once Legendary ring is obtained
            //actions.cleave+=/colossus_smash,if=buff.shattered_defenses.down&buff.precise_strikes.down
            if (await S.Cast(SB.spellColossusSmash, !U.shatteredDefenses /*&& !U.preciseStrikes*/)) return true; //<~ Add in the Precise Strikes artifact trait once obtained
            //actions.cleave+=/warbreaker,if=buff.shattered_defenses.down
            if (await S.Cast(SB.artifactWarbreaker, !U.shatteredDefenses)) return true;
            //actions.cleave+=/focused_rage,if=buff.shattered_defenses.down
            await S.GCD(SB.talentFocusedRage, !U.shatteredDefenses);
            //actions.cleave+=/whirlwind,if=talent.fervor_of_battle.enabled&(debuff.colossus_smash.up|rage.deficit<50)&(!talent.focused_rage.enabled|buff.battle_cry_deadly_calm.up|buff.cleave.up)
            if (await S.Cast(SB.spellWhirlwind, T.fervorOfBattle == 1 && (U.colossusSmash || U.Rage > 50) && (T.focusedRage == 0 || U.battleCryDeadlyCalm || U.Cleave))) return true;
            //actions.cleave+=/rend,if=remains<=duration*0.3

            //actions.cleave+=/bladestorm
            if (await S.Cast(SB.spellBladestorm, true)) return true;
            //actions.cleave+=/cleave
            if (await S.Cast(SB.spellCleave, true)) return true;
            //actions.cleave+=/whirlwind,if=rage>=100|buff.focused_rage.stack=3
            return await S.Cast(SB.spellWhirlwind, U.Rage > 99 || U.focusedRage == 3);
            //actions.cleave+=/shockwave

            //actions.cleave+=/storm_bolt

        }
        #endregion

        #region [Method] - Area of Effect
        public static async Task<bool> AoE()
        {
            //actions.aoe=mortal_strike
            if (await S.Cast(SB.spellMortalStrike, true)) return true;
            //actions.aoe+=/execute,if=buff.stone_heart.react
            //if (await S.Cast(SB.spellExecute, U.canExecute /*&& U.stoneHeart*/)) return true; //<~ Add in Stone Heart buff once Legendary ring is obtained
            //actions.aoe+=/colossus_smash,if=buff.shattered_defenses.down&buff.precise_strikes.down
            if (await S.Cast(SB.spellColossusSmash, !U.shatteredDefenses /*&& !U.preciseStrikes*/)) return true; //<~ Add in the Precise Strikes artifact trait once obtained
            //actions.aoe+=/warbreaker,if=buff.shattered_defenses.down
            if (await S.Cast(SB.artifactWarbreaker, !U.shatteredDefenses)) return true;
            //actions.aoe+=/whirlwind,if=talent.fervor_of_battle.enabled&(debuff.colossus_smash.up|rage.deficit<50)&(!talent.focused_rage.enabled|buff.battle_cry_deadly_calm.up|buff.cleave.up)
            if (await S.Cast(SB.spellWhirlwind, T.fervorOfBattle == 1 && (U.colossusSmash || U.Rage > 50) && (T.focusedRage == 0 || U.battleCryDeadlyCalm || U.Cleave))) return true;
            //actions.aoe+=/rend,if=remains<=duration*0.3

            //actions.aoe+=/bladestorm
            if (await S.Cast(SB.spellBladestorm, true)) return true;
            //actions.aoe+=/cleave
            if (await S.Cast(SB.spellCleave, true)) return true;
            //actions.aoe+=/whirlwind,if=rage>=60
            return await S.Cast(SB.spellWhirlwind, U.Rage > 59);
            //actions.aoe+=/shockwave

            //actions.aoe+=/storm_bolt

        }
        #endregion

        #region [Method] - Execute
        public static async Task<bool> Execute()
        {
            //actions.execute=focused_rage,if=buff.focused_rage.stack<3&debuff.colossus_smash.down
            await S.GCD(SB.talentFocusedRage, U.focusedRage < 3 && !U.colossusSmash);
            //actions.execute+=/mortal_strike,if=buff.battle_cry.up&(buff.focused_rage.stack=3|buff.focused_rage.stack=2&buff.battle_cry.remains<gcd)
            if (await S.Cast(SB.spellMortalStrike, U.battleCry && (U.focusedRage == 3 || U.focusedRage == 2 && U.auraTimeLeft(Me, SB.auraBattleCry) < 1000))) return true; //<~ Will need to find a way to return GCD as it will change with player haste
            //actions.execute+=/execute,if=buff.battle_cry_deadly_calm.up
            if (await S.Cast(SB.spellExecute, U.battleCryDeadlyCalm)) return true;
            //actions.execute+=/colossus_smash,if=buff.shattered_defenses.down
            if (await S.Cast(SB.spellColossusSmash, !U.shatteredDefenses)) return true;
            //actions.execute+=/warbreaker,if=buff.shattered_defenses.down&rage<=30
            if (await S.Cast(SB.artifactWarbreaker, !U.shatteredDefenses && U.Rage < 31)) return true;
            //actions.execute+=/execute,if=buff.shattered_defenses.up
            if (await S.Cast(SB.spellExecute, U.shatteredDefenses)) return true;
            //actions.execute+=/mortal_strike,if=buff.focused_rage.stack=3
            if (await S.Cast(SB.spellMortalStrike, U.focusedRage == 3)) return true;
            //actions.execute+=/execute,if=debuff.colossus_smash.up
            return await S.Cast(SB.spellExecute, U.colossusSmash);
            //# actions.single+=/heroic_charge,if=rage.deficit>=40&(!cooldown.heroic_leap.remains|swing.mh.remains>1.2)

            //#Remove the # above to run out of melee and charge back in for rage.
            //actions.execute+=/bladestorm,interrupt=1,if=raid_event.adds.in>90|!raid_event.adds.exists|spell_targets.bladestorm_mh>desired_targets

        }
        #endregion

        #region [Method] - Single Target
        public static async Task<bool> singleTarget()
        {
            //actions.single=mortal_strike,if=buff.battle_cry.up&buff.focused_rage.stack>=1&buff.battle_cry.remains<gcd
            if (await S.Cast(SB.spellMortalStrike, U.battleCry && U.focusedRage > 0 && U.auraTimeLeft(Me, SB.auraBattleCry) < 1000)) return true;
            //actions.single+=/colossus_smash,if=buff.shattered_defenses.down
            if (await S.Cast(SB.spellColossusSmash, !U.shatteredDefenses)) return true;
            //actions.single+=/warbreaker,if=buff.shattered_defenses.down&cooldown.mortal_strike.remains<gcd
            if (await S.Cast(SB.artifactWarbreaker, !U.shatteredDefenses && S.cooldownTimeLeft(SB.spellMortalStrike) < 1000)) return true;
            //actions.single+=/focused_rage,if=buff.focused_rage.stack<3&(buff.shattered_defenses.up|cooldown.colossus_smash.remains)
            await S.GCD(SB.talentFocusedRage, U.focusedRage < 3 && (U.shatteredDefenses || S.onCooldown(SB.spellColossusSmash)));
            //actions.single+=/mortal_strike
            if (await S.Cast(SB.spellMortalStrike, true)) return true;
            //actions.single+=/execute,if=buff.stone_heart.react

            //actions.single+=/slam,if=buff.battle_cry_deadly_calm.up|buff.focused_rage.stack=3|rage.deficit<=30
            return await S.Cast(SB.spellSlam, U.battleCryDeadlyCalm || U.focusedRage == 3 || U.Rage > 71);
            //actions.single+=/execute,if=equipped.137060

            //actions.single+=/slam,if=equipped.137060

            //actions.single+=/focused_rage,if=equipped.137060

            //# actions.single+=/heroic_charge,if=rage.deficit>=40&(!cooldown.heroic_leap.remains|swing.mh.remains>1.2)

            //#Remove the # above to run out of melee and charge back in for rage.
            //actions.single+=/bladestorm,interrupt=1,if=raid_event.adds.in>90|!raid_event.adds.exists|spell_targets.bladestorm_mh>desired_targets
               
        }
        #endregion

        #endregion
    }
}