﻿using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot.Routines;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

#region [Method] - Class Redundancy
using HK = _Perdition_s_Reprieve____Arms.Core.Managers.Hotkeys;
using T = _Perdition_s_Reprieve____Arms.Rotation.Tactics;
using U = _Perdition_s_Reprieve____Arms.Core.Unit;
#endregion

namespace _Perdition_s_Reprieve____Arms
{
    public class Main : CombatRoutine
    {
        private static readonly Version version = new Version(09, 15, 2016);
        public override string Name { get { return "[Perdition's Reprieve] - Arms v" + version; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        public override WoWClass Class { get { return Me.Level > 9 ? WoWClass.Warrior : WoWClass.None; } }

        #region [Method] - Implementations
        //public override Composite PreCombatBuffBehavior { get { return new ActionRunCoroutine(ctx => T.PreCombatBuffing()); } }
        public override Composite CombatBuffBehavior { get { return new ActionRunCoroutine(ctx => T.combatBuffing()); } }
        public override Composite CombatBehavior { get { return new ActionRunCoroutine(ctx => T.rotationSelector()); } }

        #region [Method] - Hidden Overrides
        public override void Initialize()
        {
            Logging.Write(Colors.Tan, "Hello {0}", Me.SafeName);
            Logging.Write("");
            Logging.Write(Colors.Tan, "For optimal performance, please use: Tyreal/Enyo");
            Logging.Write("");
            Logging.Write(Colors.Tan, "Current Version");
            Logging.Write(Colors.Tan, "-- v" + version + " --");
            Logging.Write(Colors.Tan, "-- By Dagradt --");
            Logging.Write(Colors.Tan, "-- A Warrior's Combat Routine --");
            HK.registerHotkeys();
        }
        public override bool WantButton { get { return true; } }
        public override void OnButtonPress() { Logging.Write(Colors.Firebrick, ">> Under Construction <<"); }
        public override void ShutDown() { HK.removeHotkeys(); }
        #endregion

        #region [Method] - Pulse
        public override void Pulse()
        {
            if (!StyxWoW.IsInGame || !StyxWoW.IsInWorld || Me == null || !Me.IsValid || !Me.IsAlive)
                return;
            if (!Me.Combat)
                return;
            U.Cache();
            U.enemyAnnex(8f); //<~ Set this to whatever our smallest AoE spell's range is
        }
        #endregion

        #region [Method] - Capability Flags
        public override CapabilityFlags SupportedCapabilities
        {
            get { return CapabilityFlags.Aoe | CapabilityFlags.DefensiveCooldowns | CapabilityFlags.GapCloser | CapabilityFlags.OffensiveCooldowns | CapabilityFlags.SpecialAttacks; }
        }
        #endregion

        #endregion
    }
}